# grumphp.yml
grumphp:
    hooks_dir: ~
    hooks_preset: local
    ignore_unstaged_changes: false
    stop_on_failure: false
    hide_circumvention_tip: false
    process_timeout: null
    ascii:
        failed: ~
        succeeded: ~
    parallel:
        enabled: true
        max_workers: 32
    fixer:
        enabled: true
        fix_by_default: false

    tasks:
        yamllint:
            ignore_patterns:  []
            object_support: false
            exception_on_invalid_type: false

        file_size:
            max_size: 5M
            ignore_patterns: []

        phplint:
            exclude: ['vendor']
            jobs: ~

        git_blacklist:
            keywords:
                - 'die;'
                - 'echo'
                - 'exit;'
                - 'print('
                - 'print_r('
                - 'var_dump('
                - 'dump('
                - 'die('
                - 'exit('
            triggered_by: [php]
            whitelist_patterns:
                - '/^src\/(.*)/'
            regexp_type: G

        phpcs:
            standard: './check-style.xml'
            encoding: 'UTF-8'
            triggered_by: [php]
            warning_severity: 0
            whitelist_patterns:
                - '/^src\/(.*)/'

        phpversion:
            project: '8.0.0'

        phpcpd:
            directory: ['src']
            exclude: ['vendor', 'etc', 'bin', 'var', 'tests', 'config', 'doc', 'migrations', 'templates', 'translations']
            fuzzy: false
            min_lines: 5
            min_tokens: 70
            triggered_by: [php]

        phpunit: ~

        git_branch_name:
            whitelist:
                - '/^([0-9]+.[0-9]+.[0-9]+)|^(master)|^(feature|doc|fix|hotfix)\/([a-z-\-]+)/'
            additional_modifiers: ''

    testsuites:
        check-php:
            tasks:
                - phplint
                - file_size

        check-php-version:
            tasks:
                - phpversion

        check-php-cpd:
            tasks:
                - phpcpd

        check-php-cs:
            tasks:
                - phpcs

        check-yaml:
            tasks:
                - yamllint

        check-git:
            tasks:
                - git_branch_name
                - git_blacklist

        units-tests:
            tasks:
                - phpunit
